-- Dual Input Register  Rob Chapman  Mar 2, 1998

-- One of two inputs is selected and becomes the output on the positive
-- going edge of the clock if the store signal is asserted.
-- The number of bits is set by mapping 'width'.

Library IEEE;
use IEEE.STD_Logic_1164.all;

entity Dir is
  generic ( width : positive := 4 );
  port ( din1, din2          : in std_logic_vector(width-1 downto 0);
         d1_d2, clock, store : in std_logic;
         dout                : out std_logic_vector(width-1 downto 0));
end;

architecture behavioural of Dir is
begin

  -- map one of the inputs to the output on positive edge of clock
  process
  begin
    wait until clock = '1';
      if  store = '1'  then
        if  d1_d2 = '0'  then
          dout <= din1;
        else
          dout <= din2;
        end if;
      end if;
  end process;

end behavioural;
