Library IEEE;
use ieee.std_logic_1164.all;
--use work.sp_defs.all;

entity FunctionUnit is
	generic ( width : positive := 8 );
  	port ( 	selfunction :  in std_logic_vector( 2 downto 0 );
         	in1, in2    :  in std_logic_vector( width-1 downto 0 );
    		out1, out2  : out std_logic_vector( width-1 downto 0 )
		 );
end;

architecture behaviour of FunctionUnit is
  
begin
  f1: process(selfunction, in1, in2) -- , rightin, leftin)
    variable bittest : bit;
  begin
    case selfunction is

      when "000" =>  -- interchange the two values
        out1 <= in2;
        out2 <= in1;
--      when "001" =>  -- logical AND function as well as logical OR
--        out1 <= in1 and in2;
--        out2 <= in1  or in2;

--      when "010" =>  -- inversion as well as logical right shift one bit
--        out1 <= not in1;
--        for I in 1 to out2'high loop
--          out2(I-1) <= in2(I);
--        end loop;

--        out2(out2'high) <= '0';
--      when "011" => -- logical left shift as well as test for zero
--        for I in 1 to in1'high loop
--          out1(I) <= in1(I-1);
--       end loop;

--        out1(0) <= '0';

--	bittest := '0';

--	for I in in2'range loop
--	  bittest := bittest or to_bit(in2(I));
--	end loop;
--        for I in out2'range loop
--          out2(I) <= to_stdulogic(not bittest);
--        end loop;

      when "100" =>  -- part of an addition function
        for I in 1 to out1'high loop  -- take care of parallel carries
          out1(I) <= in1(I-1) and in2(I-1);
        end loop;

        out1(0) <= '0';
        out2 <= in1 xor in2;  -- take a bit sum

      when "101" =>  -- part of a subtraction function
        for I in 1 to out1'high loop  -- take care of borrows
          out1(I) <= ( not in1(I-1) ) and in2(I-1);
        end loop;

        out1(0) <= '1';
        out2 <= (not in1) xor in2;  -- subtract a bit

      when others =>  -- just connect for now
        out1 <= in2;
        out2 <= in1;
      
    end case;
  end process;
end behaviour;

