Library IEEE;
use IEEE.STD_Logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use work.sp_defs.all;

entity ProgramCounter is
  generic ( width : integer := 8 );
  port ( ain1, ain2 : in std_logic_vector( width-1 downto 0);
         clock,reset: in std_logic;
         control    : in std_logic_vector(1 downto 0);
         aoutport   : out std_logic_vector( width-1 downto 0)
		);
end;

architecture behaviour of ProgramCounter is
	subtype pc_cell is std_logic_vector( width-1 downto 0 );

	signal natanext, nataout: natural;
	signal aout, anext : pc_cell;
	constant pczero : pc_cell := (others => '0');

begin
  -- Send signal to output port port
	aoutport <= aout;

  -- do stuff
  program_counter : process(clock,reset) is
  begin  

    if  reset = '1'  then
      aout <= pczero;
    elsif  clock = '1' and clock'event  then
      case control is
        when "00" =>  -- increment
          aout <= aout + 1;
        when "01" =>  -- hold
          aout <= aout;
        when "10" =>  -- jump 1
          aout <= ain1;
        when "11" =>  -- jump 2
          aout <= ain2;
		when others => 
          aout <= aout;
      end case;

    end if;
  end process;

end behaviour;
